Changelog for version 1.3.4500

Bugfixes:
* Fixed crash with AC3 encoding
* Fixed bug that caused ffdshow to connect its subtitle pin even when subtitles were disabled
* Removed support for raw NV12 input. It caused crashes with resize enabled.
* SPP deblocking: fixed crash when the video has an unsupported format.

Changes:
* Now useslibavcodec by default for AC3 decoding
* Disabled "Allow direct-to-file output" by default. It causes playback problems in WMP12 in some situations.
* Embedded subtitle support is now enabled by default.
* Re-added VobSub support. Labeled it as "incomplete" because of the known bugs.
* Removed makeAVIs from 64-bit build. It caused crashes on Windows 8.
* Hide VFW option in 64-bit build on Windows 8. It causes crashes.
* Updated blacklist and whitelist
* Optimization of SPP deblocking by use of multi-threading and SSSE3
* Improved auto post-processing
* Removed real time subtitle text correction feature
* Removed libmpeg2

Updates:
* IntelQuickSync r77
* Boost v1.51
* Unrar v4.20
* zlib v1.2.7
* Some libavcodec updates


Changelog for version 1.2.4422

Bugfixes:
* Lots of updates for libavcodec that bring bug fixes, performance enhancements, and security fixes.
* Disable "Detect soft telecine and average frame durations" if 3:2 pulldown is being applied in AviSynth filter.
* IAMStreamSelect: fix duplicated subtitle list in case of multiple ffdshow instances
* If a matroska container had hidden leading chapter and Haali's splitter was used and tray icon was right-clicked, ffdshow crashed.
* Various fixes regarding input mediatype handling, strides, and pin re-connection.
* Various fixes regarding H.264 SPS parsing
* Fixed decoding of 96khz 32bit audio with libavcodec
* Fixed decoding of AAC audio with libavcodec when extradata is missing
* Better handling of non-mod4 resolutions
* Workaround for freeze in Powerpoint 2010
* AC3 encoder was producing improper bitstream when connected to file writer filter
* Various fixes for audio bitstreaming

New and improved features:
* Support for H.264 10-bit 4:2:0/4:2:2/4:4:4/RGB
* Support for H.264 8-bit 4:2:2/4:4:4/RGB, 4:2:0 was already supported
* Support for various 10-bit and 16-bit colorspaces
* Optimized YV12 to NV12 conversion
* Enabled high quality RGB32 conversion by default
* Added option to select a preferred output colorspace
* Added Intel QuickSync decoder. This provides hardware acceleration decoding of H.264, VC-1 and MPEG-2. Requires the integrated GPU of Intel Sandy Bridge processors.
* Added DXVA video filter for hardware accelerated decoding. Supports H.264 and VC-1 video. Also includes subtitle support.
* Various additions to the application blacklist and whitelist
* Added support for Blu-ray PGS subtitles
* Removed support for USF subtitles
* Various improvements for the handling of ASS/SSA subtitles. More tags are supported now, but not yet all of them.
* Various improvements for the rendering of text-based subtitles
* By default now only subtitle files are shown that match the video filename. This behavior can be adjusted through an option on the "Try, dialog & Paths" page in ffdshow settings.
* Created new format option in ffdshow audio decoder for the QT PCM variants (such as TWOS). They were previously part if the Uncompressed audio option.
* ffmpeg-mt has been merged into libavcodec
* Multi-threaded decoding is now used by default for H.264, MPEG-1/2, FFV1, and DV video.
* Added decoding support for Indeo 4 and Indeo 5 video
* Floating point output for libavcodec AAC, AC3, E-AC3, DTS, Vorbis, and Nellymoser decoders.
* Added option to disable jitter correction for audio decoder
* Improved performance of Deband filter
* Removed some encoders for which the interface that ffdshow provided was outdated and unmaintained, such as Xvid and H.264. You should use the official codecs instead.
* Removed some encoders that were considered obsolete or unstable.

Updates:
* Updated Boost library to v1.49
* Updated zlib library to v1.2.6
* Updated minilzo library to v2.06
* Updated unrar library to v4.10
* Updated libsamplerate to v0.1.8
* Removed mp3lib
* Removed xvidcore

--------------------------------------------------------------------------------

Changelog for Beta 7 (r3154)
Bugfixes
 * Various H.264 and MPEG-2 seeking issues fixed
 * Several memory leak fixes
 * Subtitle fixes:
   * Don't show closed caption if "Subtitles" is not checked
   * Non-DVD subtitles: check if "Subtitles" is checked before showing subtitles
   * Setting "Maintain outside text inside screen" was not always applied correctly
   * Subtitle file could not be disabled during DVD playback
   * Duration of SSA move tags was randomly applied
   * Various fixes to alignment, line spacing, movement and positioning of ASS, SSA and SRT subtitles
   * Several crash fixes
 * Fixes in the Audio mixer and LFE crossover filter:
   * Center and LFE were too loud when downmixing 5.1 --> 2ch
   * If the original sound had LFE channel, it was overwritten
   * If the center channel existed, left and right channels were ignored
 * Several MLP/TrueHD/LPCM decoding fixes
 * Playing a CSS-protected DVD using MPC or MPC-HC caused a crash in certain scenarios
 * Fixed DVD menu positioning and freeze issue
 * Fixed several crashes in WMP11 and Media Center
 * ffdshow.ax failed to register when a registry key was missing
 * Removed black lines in Perspective Correction filter
 * ffdshow would crash when using the Grab filter and the Resize filter with aspect ratio correction
 * Many fixes across multiple ffdshow components including OSD, deinterlacing, remote API, DVD and MPEG-2 playback

New and improved features
 * New multi-threaded H.264 decoder: ffmpeg-mt
 * DTS-HD and Dolby TrueHD bitstreaming support for the ATI Radeon HD5000 series, ASUS Xonar sound cards and Intel Clarkdale CPUs
 * New color space converters:
   * Supported input color spaces: progressive YV12, progressive NV12, YV16, YUY2
   * Supported output color spaces: RGB24, RGB32
   * High quality chroma upscaling
   * Added dithering to reduce "banding"
   * Support for color primary parameters such as ITU-R BT.601/709, input and output levels
   * RGB conversion done in 11-bit or higher
   * Significant improvements in YV12 --> YUY2, YUY2 --> RGB, and YV12 --> RGB conversion performance
   * Requires SSE2-capable CPU; for better performance multi-core CPU recommended
 * New RGB conversion options:
   * Output levels ("Computer monitor" or "TV/Projector")
   * YCbCr specification "Auto" (uses H.264's VUI or width > 1024: BT.709, width <= 1024: BT.601)
 * Various improvements in the Subtitle filter:
   * Improved rendering quality, memory usage and performance
   * General code cleanup
   * SSA/ASS subtitles: better compatibility (support for position & move tags), better calculation of line wrapping, new dialog to configure ASS specific options. Also support added for ASS tags within SRT subtitles (SubViewer)
 * FFDShowAPI: .NET wrapper around FFDShowRemoteAPI allows integration of ffdshow with third-party applications
 * FFDShowRemoteAPI:
   * Improved subtitle/audio streams detection; now compatible with most filters handling the IAMStreamSelect interface
   * New command to disable FF/RW OSD
   * When using absolute positioning, x and y coordinates are now representing pixels instead of percentages
   * Added new parameter to determine the duration in which a message will be displayed
 * OSD settings are now based on the current ffdshow preset; this allows turning OSD on/off using the "Automatic preset loading" mechanism
 * Buffered video RAM access improves video memory access in certain scenarios
 * AviSynth filter now uses AviSynth's frames for buffering which improves performance and reduces the filter's memory usage
 * "Max. amplification" in the Normalization filter will only be applied after pressing "Apply"
 * Better handling of DVD menus
 * Improved autocrop algorithm
 * Added RealVideo 8 (RV30) support
 * Added soft telecine detection
 * Added several new preset autoload conditions
 * libavcodec is now used by default to decode Theora videos
 * libavcodec is now used as Dolby TrueHD decoder instead of MLP
 * Various updates to libavcodec

Changelog for Beta 6
Bugfixes
 * Important security fix: Buffer overflow vulnerability was fixed
 * Fixes to ffdshow's remote API
 * GDI resource leak fix
 * Subtitle fixes:
   * Fixed missing character at the end of line with non-UTF8 encoding in embedded subtitles
   * When activating SSA tags within SRT subs, default placement (with no tag) was not correct
   * Subtitle stability fix for random crashes
 * Workaround for crashes in applications that use the Windows Media Player SDK
 * Wrong color fix for Fraps v5
 * The Grab filter was producing a black right border when saving PNG images having a width which was not a multiple of 16
 * OSD / Info & CPU: Show correct value in "Movie FPS"
 * Crash due to a language file size limit was fixed

New and improved features
 * Added support for E-AC3 decoding (Dolby Digital Plus)
 * Added support for DTS-HD decoding (core DTS only)
 * Added support for Dolby TrueHD and MLP decoding (full TrueHD decoding or AC3 can pass-through depending on config)
 * New deinterlacer: yadif (Yet Another DeInterlacing Filter)
 * Updated libavcodec with the latest code from the FFmpeg project
 * Volume normalization:
   * One-pass normalization added. This mode is used to reach the highest possible loudness with minimum of possible artifacts
   * Improved normalization, the probability of clipping has been decreased
 * Added support for S/PDIF sample rates other than 48kHz: Pass-through of 44.1kHz AC3/DTS streams plays back correctly now
 * Dynamic range compression level for AC3 and E-AC3 sources can now be set between 0 and 100%
 * AC3/DTS pass-through settings are now based on presets
 * DVD playback support by libavcodec
 * Tweaked compatibility list reporting: Executable names that are not yet in the default whitelist/blacklist are now reported only
 * Unicode support for FFDShowRemoteAPI
 * Language file size limit was increased, all language files are now encoded as UTF-16LE+BOM
 * Various OSD updates:
   * Buffer limit increased from 256 to 2048 characters
   * HTML encoding support similar to SRT files
   * Added SSA support for OSD and combobox to select the format (HTML/SSA)
 * SRT files with tags support: SSA tags support in SRT files and HTML tags support in SSA files
 * Improved compatibility with certain MPEG2 Transport / Program Stream demultiplexers (e.g. DVBSource, Elecard) for files that contain H.264 video
 * Support H.264 digital television playback in DVBViewer
 * Improved H.264 seeking
 * Added an option to deinterlace only frames flagged as "interlaced"
 * Enhanced interlacing options allow to choose the method (auto, weave, bob) as well as the field order (auto, top field, bottom field)
 * Color space conversion: Added option "Force progressive" and "Force interlace"
 * Flag telecined frames as progressive (libmpeg2)
 * H.264: Correct field order, interlace/progressive flags are decoded

Changelog for Beta 5
Bugfixes
 * If resize was enabled, DVD menu was not positioned correctly.
 * In Windows Media Center on Vista, AVI files that have non-square aspect ratio could not be played properly due to a bug in Windows Media Center. Now, if you check both "Allow output format changes during playback" and "Connect to compatible filters only", these files play with correct aspect ratio.
 * If ffdshow was inputting NV12/NV21 as raw video and resize was enabled, ffdshow crashed.
 * "Bitmap overlay" crashed.
 * DCT image filter for playback was not working.
 * In subtitle filter, if "Overlap subtitles with same time" was checked, ffdshow sometimes crashed.
 * The subtitles letterbox erroneously applied cropping instead of letterboxing if the specified AR was wider than the AR of the given video.
 * Windows Media Center crashed on creating thumbnails.

New features
 * YV16: Add support as input color space.
 * Support for VC1 on TS container.
 * ASS subtitle: Support karaoke (incomplete).
 * ASS subtitle: Support fade in/out.
 * Improved multithreading of H.264 decoder.
 * Added support for the FourCCs "SP51" to "SP57".
 * Enabled user setting of "Correct aspect ratio automatically" for SSA/ASS too, because VSFilter and MPC's VMR9 renderless have different behavior.

Changelog for Beta 4
Bugfixes
 * In FLAC and TTA, A/V synch was lost.
 * Closed caption decoder produced garbled characters.
 * Crashes in Windows Movie Maker have been fixed.
 * Subtitles that contain an "&" as part of the filename were displayed incorrectly inside ffdshow's context menu.
 * MakeAVIS.exe in "Store uncompressed audio" mode produced noisy audio if the input audio was not 16bit integer.
 * If the AviSynth script had multiple lines, the script was not saved by using "Export all settings" or "Save to file..." in Presets page.
 * DTS S/PDIF pass-through sometimes had terrible noise.
 * Compatibility problem with VFW encoder applications such as HyperCam has been fixed.
 * If ConvertToRGB was used in AviSynth script, the video was flipped.
 * If "Swap channels" was used, audio was lost if the number of channels of the input stream changed.
 * DVD menu was sometimes not highlighted.
 * "Preset autoload conditions" --> "on movie file name match (with wildcards)" did not work.
 * If the input color space was NV12 or NV21, ffdshow could not render properly.
 * If crop was used after letterbox subtitling, the bottom of the image was cropped too much.

New features
 * Nellymoser audio decoder has been added. The latest FLV Splitter is required.
 * Seb's BTB&WTW level filter: Adjust contrast only if the "dimmer than dimmest" (Y < 16) and/or the "brighter than brightest" (Y > 235) part exist (depending on the configuration).
 * H.264-PAFF interlacing is now supported.
 * H.264 decoder has been multithreaded. It is only effective if the video is encoded using multiple slices.
 * Added reset button to overlay control.
 * You no longer have to use LoadCPlugin / Load_Stdcall_Plugin for loading ffavisynth.dll (ffdshow() and ffdshowAudio() function). It is automatically loaded on AviSynth start-up.
 * In "YCbCr <-> RGB conversion", ITU-R BT.601/709 standard selection and contrast configuration (standard, full range, custom) has been added.
 * 7.1ch audio processing has been added.
 * In "Crop & zoom", "Auto crop" has been added. Black borders can be removed automatically.
 * Preset auto loading: Now you can select either "On one of the conditions match (OR)" or "On all conditions match (AND)".
 * In preset auto loading, "on FOURCC from previous filter match" has been added. It is useful when ffdshow is used in RAW mode to affect a condition on the original video FOURCC.
 * For Windows Media Player 11 and Windows Media Center on Vista, a new option for RAW video processing has been added.
 * In "Resize & aspect", "Resize to screen resolution" has been added.
 * In "Resize & aspect" --> "Process pixel aspect ratio internally", PAR of output device can be configured now.
 * In "Resize & aspect" --> "Borders", the way of dividing borders can be configured now. It's useful when you use subtitles.
 * Vertical scaling of text subtitles. ASS subtitles can also be scaled with a new option called "Override ASS/ASS2 scaling".
 * Added text subtitle blur. Better blend in with the video.
 * New OSD item "Active preset name".
 * Subtitle word wrapping: Three modes are available. "Smart wrapping, lines are evenly broken", "End-of-line word wrapping" and "Smart wrapping, lower line gets wider".
 * Experimental x64 builds are available.
 * Faster RGB <-> YV12 conversion for x64.
 * Improved text subtitles and OSD rendering. Body, outline and shadow options have separately adjustable color and alpha settings. If the output color space is RGB and no other image filter (except resize) is used in the downstream, subtitles and OSD are rendered in RGB mode and the quality is improved further.
 * Multiple languages support: A horizontal scaling ratio for the config dialogs can be configured from language files. To scale them to 125% horizontally add the two lines "horizontalScale9x=125" and "horizontalScaleNT=125" in the "[Font]" section of the language file.
 * Improved German translation (making use of the extra space gained by scaling horizontally).

Changelog for Beta 3
Bugfixes
 * Black borders were not painted black in AviSynth filter and deinterlacers.
 * libavcodec encoders did not accept frame rates except 25fps. Other encoders sometimes had inaccurate frame rates.
 * If ffdshowaudio() was used in AviSynth script, an error occurred.
 * If a Unicode subtitle file contained 0x1a, the rendering failed.
 * The image got mirrored if AviSynth filter output in RGB color space.
 * If "RAW video" --> "YV12" in VFW decoder was enabled, the image got mirrored when VFW codec was used via DirectShow.
 * Improved stability of Winamp plugin handling.
 * On the fly resize: If you entered 8 (as the first digit of 800) for the vertical size, it crashed depending on the used method (lanczos tap>=4, spline, etc).
 * If resize was being used, changes to the pixel aspect ratio (SAR) of the video were ignored.
 * If "Resize & aspect" --> "Borders" --> "Inside" was used, "Keep original aspect ratio" calculated wrong size.
 * AviSynth script could not be saved (Unicode builds only).

New features
 * Deinterlacing support (set interlace flag) for MPEG4-ASP through Xvidcore decoder.
 * A dialog is shown when an unknown application (which is neither listed in the blacklist nor in the whitelist) tries to load ffdshow.
 * libavcodec encoders pop up error messages.
 * The AviSynth filter was updated to give scripts access to more frames than just the current one. Together with the added "3:2 pulldown" settings this allows many of the IVTC, deinterlacing and temporal filters for AviSynth to work properly in ffdshow.
 * Updated icons. Classic icons are still available.
 * ATRAC3 (Adaptive TRansform Acoustic Coding, compressed audio format) has been added.
 * Xvid encoder has been multithreaded.
 * Support for SPDIF on Windows Vista has been added ("Audio decoder configuration" --> "Output" --> "Connect to:").
 * Multichannel audio processing by Winamp plugins has been added.
 * In "Resize & aspect" dialog, a new check box "Process pixel aspect ratio internally" has been added.
 * Resize GUI: "Specify horizontal size" instead of "Specify vertical size 0 for auto".
 * Audio decoder AC3 output: the new check box "Encode only multichannel streams" allows sending multichannel audio (which otherwise cannot be digitally sent) to AV-amp in AC3-SPDIF.

Changelog for Beta 2
Bugfixes
 * After changing aspect ratio, the height of the picture halved, if you used overlay mixer and YUY2. It was common on DVD playback.
 * FFV1 decoder crashed on seeks or delay.
 * FFV1 encoder: default key frame distance value was 250, which was too high and could not be configured independently. New default is 10.
 * When NV12 was the only available output color space for DirectShow decoder and "Raw video" was enabled for VFW decoder, Windows Media Player 11 thumbnailer crashed.
 * Subtitle was gray, even if you selected white.
 * Deleting the active and default preset settings caused a crash.
 * Flipped NV12 caused either crash or corrupt image.
 * Using Media Player Classic's internal Matroska splitter, the aspect ratio was always 1.
 * When you opened audio configuration dialog during playback, the CPU usage was abnormally high and it sometimes froze especially on ADPCM audio.
 * When ffdshow connected to VobSub (VSFilter), ffdshow tried to use YV12 plus width of non-multiple of 8 and ended in crash.
 * When you configured "Resize & aspect" --> "Borders" --> "Inside" --> "100%", ffdshow ended in crash.
 * Reconnecting to VMR9 (after resizing) sometimes failed.
 * PowerDVD7 produced a black screen because of a bug in DirectShow filter's connecting code (please remove PowerDVD.exe from "DirectShow control" --> "Don't use ffdshow in:").
 * If a subtitle unit contained too many lines for the specified space, lines were being dropped.
 * The right edges of italic subtitles were cut off. If "fast rendering" was enabled, italic text was sometimes shown as non-italic and vice versa.
 * Some SVQ3 videos caused freeze.
 * Changing Matroska subtitles track ended in a crash.
 * Multibyte characters in Matroska-embedded subtitles were garbled.
 * If noise and resize filters were applied, chroma became green.
 * Explorer.exe crashed on Windows Vista when accessing a folder that contains AVI files.
 * Playing or seeking in MPEG1/2 videos using libmpeg2, sometimes produced ugly green artifacts or ended with a crash (libmpeg2).
 * Fixed OGG & OGM muxers. Removed FLV & MPEG muxers.
 * When you played a video which height was not a multiple of four, it crashed or artifacts were seen depending on the output color space.
 * When you played a video which width was over 1024, it crashed when using RGB to YUY2 conversion.
 * When you played a video which height was an odd number and YV12 was enabled, the video became distorted.
 * If ffdshow was connected to Haali's video renderer, seeking sometimes failed.
 * The next internal filter of Kernel deinterlace was skipped on every other frame. If the next internal filter was "Resize", the video size changed on every frame.

New features
 * Improved subtitle shadow. 3 shadow modes are available: classic, glowing and gradient.
 * Management of compatibility issues: "Use ffdshow only in:" option ensures that ffdshow only runs in supported applications.
 * Hardware deinterlacing support for RAW video (interlacing-related information which was input as RAW video is being sent to downstream filters).
 * New OSD item "IDCT(libavcodec)" displays which IDCT method is used.
 * In "Subtitles" --> "Search in", extensions priority can be specified.
 * VC-1 Advanced Profile support (libavcodec can work without external codecs).
 * Various WMV and VC-1 content can be played using Microsoft's codec (VC-1 needs external codec or WMP11 installed).
 * x264 encoder re-added and updated.
 * Deinterlacing support (set interlace flag) for H.264 MBAFF.
 * Corrections and new features of the Remote API: presets, subtitles, fast forward/backward etc.
 * Polish Inno Setup translation
 * Queue: ffdshow now uses VMR9's internal queue.

Changelog for Beta 1
Bugfixes
 * When you tried to re-encode using Windows Media Encoder, ffdshow audio decoder would cause WME to crash.
 * Hardware deinterlacing did not work, when using libmpeg2.
 * AAC was played back too fast so that it was not audible. A/V synch was lost.
 * When you played a video which height was an odd number, it often froze.
 * If "Mixer" --> "headphone virtual spatialization" was enabled, it crashed on playback of mono sources.
 * When you played an Xvid stream with many consecutive N-VOPs, subtitles were not shown when no new frames were actually being displayed. If there were long consecutive N-VOPs at the end of the file, it closed too early.
 * "Video decoder configuration" --> "Output" --> "DV" couldn't be unchecked.
 * If one of the files that needed updating was locked, the installer stopped with an error message.
 * Didee's YlevelsG/S/C was not implemented correctly. It was the bright parts of the pictures that saw the most effect of the gamma.
 * ffdshow could not connect to uncompressed audio input.
 * LPCM output was broken.
 * AC3 output was broken.
 * DTS was broken with large noise.
 * Perspective correction with cubic interpolation crashed if the width of the video was over 768.
 * 5.1ch Vorbis (libavcodec) was broken.
 * When you tried to use ffdshow DirectShow decoder in PowerDVD, the video was black.
 * If ffdshow got DVD decoder's output input as RAW video, the subtitle file was valid and MPEG2 was disabled, subtitles that were not related to the DVD were shown.
 * If subtitles including video image such as IDX+SUB (VobSub) format were enabled, it crashed where the height of the subtitles was an odd number.
 * Convolver, one of the audio filters, crashed when you tried to load impulse file.
 * When you used resize, horizontal lines were sometimes seen ("Resize" --> "Settings" --> "Accurate rounding").
 * If you used resize after xsharpen, the video was green.
 * Stereoscopic subtitle crashed.
 * OSD item "CPU Load" did not show correct value in multiprocessor system.
 * Postprocessing automatic quality control did not work in multiprocessor systems.
 * Volume normalization did not work properly.
 * DScaler: Video (TomsMoComp) crashed depending on the compiler used for building.
 * Overlay control could not load initial value properly.
 * Oblivion and Morrowind (both are games) crashed.
 * On Windows Vista, codec configuration dialog was broken.
 * If there was an error in AviSynth script in ffdshow, the error message was displayed on top of video. The error message still remained after the whole AviSynth page was unchecked.
 * The dialog was garbled, if "Tray, dialog & paths" --> "Japanese (Unicode)" was selected (ANSI builds). The problem was that the installer set it by default for Japanese version of Windows.
 * ANSI/MBCS was not processed properly. For example, OSD item "Source file" couldn't show last few characters if MBCS was used in the path. It was a security concern.
 * If you used translation of the dialog, content of the dialog was scaled about 130% but the size of the window was not. As a result, you couldn't see the right, hidden part of the dialog (depending on the way to launch the dialog).
 * Subtitles were garbled if "Subtitles" --> "Font" --> "Fast rendering" was enabled and you used MBCS on ANSI builds.

New features
 * H.264 MBAFF (interlaced format) support.
 * VP6 and several other codecs have been added.
 * VC-1 Advanced Profile support for wmv9lib. You need WMP11 or Microsoft's VC-1 codec.
 * The installer can set speaker configuration. It loads the setting of the OS (control panel) as default.
 * Queue: Accelerator. It deposits the time when CPU has finished work early and uses the time when delayed.
 * Multithreaded resize: Faster resize on multi-core CPUs.
 * Calculates the vertical size automatically when you enter 0 for vertical size ("Resize" --> "Specify size" --> "New size").
 * Vorbis: High accuracy mode is enabled for tremor.
 * Quality control is now configurable ("Decoder options" --> "Quality control").
 * Show error message if the splitter failed to provide necessary information to decode SVQ3.
 * Improved translations.
